<template>
    <div class="list-view">
        <div class="filters-container">
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button> -->
            <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button>
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="100"> </el-table-column>
            <el-table-column prop="attractionsName" label="景区名称" show-overflow-tooltip> </el-table-column>
            <el-table-column prop="name" label="名称" min-width="120px"> </el-table-column>
            <el-table-column prop="price" label="价格(元)"> </el-table-column>
            <el-table-column prop="unit" label="单位"> </el-table-column>
            <el-table-column prop="categoryName" label="类型"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row, true)" type="primary" size="mini" plain>编辑</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>

        <el-dialog :visible.sync="showDialog" width="460px" title="编辑商品" :close-on-click-modal="false">
            <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small">
                <el-form-item prop="attractionsId" label="景区">
                    <el-select
                        v-model="formData.attractionsId"
                        clearable
                        filterable
                        placeholder="请选择景区"
                        class="select-width"
                    >
                        <el-option
                            v-for="item in attractionsOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value"
                        >
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item prop="img" label="图片">
                    <single-upload v-model="formData.img"></single-upload>
                </el-form-item>
                <el-form-item prop="name" label="名称">
                    <el-input v-model="formData.name" class="cl-input"></el-input>
                </el-form-item>
                <el-form-item prop="price" label="价格">
                    <el-input-number v-model="formData.price" class="cl-input"></el-input-number>
                </el-form-item>
                <el-form-item prop="unit" label="单位">
                    <el-input v-model="formData.unit" class="cl-input"></el-input>
                </el-form-item>
                <el-form-item prop="categoryId" label="类型">
                    <el-select
                        v-model="formData.categoryId"
                        clearable
                        filterable
                        placeholder="请选择"
                        class="select-width"
                    >
                        <el-option
                            v-for="item in categoryOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value"
                        >
                        </el-option>
                    </el-select>
                </el-form-item>
            </el-form>
            <span slot="footer">
                <el-button type="primary" size="mini" @click="save" :loading="saving">保存</el-button>
            </span>
        </el-dialog>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'GoodsInfoList',
    mixins: [pageableTable],
    created() {
        this.$http
            .post('/category/getChildren', { id: 730 })
            .then(res => {
                if (res.length > 0) {
                    res.forEach(item => {
                        this.categoryOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
        this.$http
            .post('/attractions/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                if (res.content.length > 0) {
                    res.content.forEach(item => {
                        this.attractionsOptions.push({
                            label: item.name,
                            value: item.id
                        });
                    });
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/goodsInfo/all',
            downloading: false,
            showDialog: false,
            formData: {},
            edit: false,
            saving: false,
            rules: {
                img: { required: true, message: '请上传图片', trigger: 'blur' },
                name: [{ required: true, message: '请输入名称', trigger: 'blur' }],
                unit: [{ required: true, message: '请输入单位', trigger: 'blur' }],
                price: [{ required: true, message: '请输入价格', trigger: 'blur' }]
            },
            categoryOptions: [],
            attractionsOptions: []
        };
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            return { search: this.search };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/goodsInfoEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/goodsInfoEdit',
                query: {
                    id: row.id
                }
            });
        },
        // editRow(row, edit) {
        //     this.edit = edit;
        //     if (!row) {
        //         row = {
        //             name: '',
        //             price: ''
        //         };
        //     }
        //     this.formData = { ...row };
        //     this.showDialog = true;
        // },
        download() {
            this.downloading = true;
            this.$axios
                .get('/goodsInfo/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/goodsInfo/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        save() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    let data = { ...this.formData };
                    this.saving = true;
                    this.$http
                        .post('/goodsInfo/save', data, { body: 'json' })
                        .then(res => {
                            this.saving = false;
                            this.$message.success('成功');
                            this.showDialog = false;
                            this.getData();
                        })
                        .catch(e => {
                            console.log(e);
                            this.saving = false;
                            this.showDialog = false;
                            this.$message.error(e.error);
                        });
                } else {
                    return false;
                }
            });
        }
    }
};
</script>
<style lang="less" scoped>
.cl-input {
    width: 250px;
}
</style>
